package Benno::Config;

use XML::LibXML;
use strict;
use Benno::Container;

sub new
{
    my $class       = shift;
    my ($filename)  = @_;

    my $self = {
        conainers => {},
        filename  => $filename,
    };
    bless $self, $class;

    $self->_init();

    return $self;
}


sub add_container
{
    my ($self,$Cnt) = @_;

    $self->{containers}->{$Cnt->{id}} = $Cnt;
}


sub get_container
{
    my ($self,$cid) = @_;

    return $self->{containers}->{$cid};
}


sub get_containers
{
    my ($self) = @_;

    my @retlist;
    foreach my $cid (keys %{$self->{containers}}) {
        push @retlist, $self->{containers}->{$cid};
    }

    return @retlist;
}


sub get_containerids
{
    my ($self) = @_;

    my @retlist;
    foreach my $cid (keys %{$self->{containers}}) {
        push @retlist, $cid;
    }

    return @retlist;
}


sub get_config
{
    my ($self,$attr) = @_;

    return $self->{config}->{$attr};
}


sub id
{
    my ($self) = @_;

    return $self->{id};
}


sub set_config
{
    my ($self,$attr,$value) = @_;

    $self->{config}->{$attr} = $value;
}


sub _init
{
    my ($self) = @_;

    my $dom = XML::LibXML->load_xml(location => $self->{filename});

    # load Container
    foreach my $xml ($dom->findnodes('//simplecontainer')) {
        $self->add_container(new Benno::Container($xml));
    }
}





### EOP ###
1;
